/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++

   Copyright (C) 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

// Take the name prefix into account.
#define yylex   velex

#include "ValueExpressionParser.tab.hh"

/* User implementation prologue.  */
#line 60 "ValueExpressionParser.yy"

#include "ValueExpressionDriver.H"
#include "ValueExpressionDriverLogicalTemplates.H"


/* Line 317 of lalr1.cc.  */
#line 49 "ValueExpressionParser.tab.cc"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

/* Enable debugging if requested.  */
#if YYDEBUG

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

namespace ve
{
#if YYERROR_VERBOSE

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  ValueExpressionParser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

#endif

  /// Build a parser object.
  ValueExpressionParser::ValueExpressionParser (ValueExpressionDriver& driver_yyarg)
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
      driver (driver_yyarg)
  {
  }

  ValueExpressionParser::~ValueExpressionParser ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  ValueExpressionParser::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
        case 3: /* "\"scalarID\"" */
#line 135 "ValueExpressionParser.yy"
	{ debug_stream () << *(yyvaluep->name); };
#line 179 "ValueExpressionParser.tab.cc"
	break;
      case 4: /* "\"vectorID\"" */
#line 135 "ValueExpressionParser.yy"
	{ debug_stream () << *(yyvaluep->vname); };
#line 184 "ValueExpressionParser.tab.cc"
	break;
      case 5: /* "\"faceScalarID\"" */
#line 135 "ValueExpressionParser.yy"
	{ debug_stream () << *(yyvaluep->fsname); };
#line 189 "ValueExpressionParser.tab.cc"
	break;
      case 6: /* "\"faceVectorID\"" */
#line 135 "ValueExpressionParser.yy"
	{ debug_stream () << *(yyvaluep->fvname); };
#line 194 "ValueExpressionParser.tab.cc"
	break;
      case 7: /* "\"cellSetID\"" */
#line 135 "ValueExpressionParser.yy"
	{ debug_stream () << *(yyvaluep->setname); };
#line 199 "ValueExpressionParser.tab.cc"
	break;
      case 8: /* "\"number\"" */
#line 138 "ValueExpressionParser.yy"
	{ debug_stream () << (yyvaluep->val); };
#line 204 "ValueExpressionParser.tab.cc"
	break;
      case 9: /* "\"vector\"" */
#line 136 "ValueExpressionParser.yy"
	{ Foam::OStringStream buff; buff << *(yyvaluep->vec); debug_stream () << buff.str().c_str(); };
#line 209 "ValueExpressionParser.tab.cc"
	break;
      case 10: /* "\"expression\"" */
#line 139 "ValueExpressionParser.yy"
	{ debug_stream () << (yyvaluep->sfield)->name().c_str(); };
#line 214 "ValueExpressionParser.tab.cc"
	break;
      case 11: /* "\"lexpression\"" */
#line 139 "ValueExpressionParser.yy"
	{ debug_stream () << (yyvaluep->sfield)->name().c_str(); };
#line 219 "ValueExpressionParser.tab.cc"
	break;
      case 12: /* "\"vexpression\"" */
#line 139 "ValueExpressionParser.yy"
	{ debug_stream () << (yyvaluep->vfield)->name().c_str(); };
#line 224 "ValueExpressionParser.tab.cc"
	break;
      case 13: /* "\"fsexpression\"" */
#line 139 "ValueExpressionParser.yy"
	{ debug_stream () << (yyvaluep->fsfield)->name().c_str(); };
#line 229 "ValueExpressionParser.tab.cc"
	break;
      case 14: /* "\"fvexpression\"" */
#line 139 "ValueExpressionParser.yy"
	{ debug_stream () << (yyvaluep->fvfield)->name().c_str(); };
#line 234 "ValueExpressionParser.tab.cc"
	break;
       default:
	  break;
      }
  }


  void
  ValueExpressionParser::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif /* ! YYDEBUG */

  void
  ValueExpressionParser::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
        case 3: /* "\"scalarID\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->name); };
#line 269 "ValueExpressionParser.tab.cc"
	break;
      case 4: /* "\"vectorID\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->vname); };
#line 274 "ValueExpressionParser.tab.cc"
	break;
      case 5: /* "\"faceScalarID\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->fsname); };
#line 279 "ValueExpressionParser.tab.cc"
	break;
      case 6: /* "\"faceVectorID\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->fvname); };
#line 284 "ValueExpressionParser.tab.cc"
	break;
      case 7: /* "\"cellSetID\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->setname); };
#line 289 "ValueExpressionParser.tab.cc"
	break;
      case 9: /* "\"vector\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->vec); };
#line 294 "ValueExpressionParser.tab.cc"
	break;
      case 10: /* "\"expression\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->sfield); };
#line 299 "ValueExpressionParser.tab.cc"
	break;
      case 11: /* "\"lexpression\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->sfield); };
#line 304 "ValueExpressionParser.tab.cc"
	break;
      case 12: /* "\"vexpression\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->vfield); };
#line 309 "ValueExpressionParser.tab.cc"
	break;
      case 13: /* "\"fsexpression\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->fsfield); };
#line 314 "ValueExpressionParser.tab.cc"
	break;
      case 14: /* "\"fvexpression\"" */
#line 137 "ValueExpressionParser.yy"
	{ delete (yyvaluep->fvfield); };
#line 319 "ValueExpressionParser.tab.cc"
	break;

	default:
	  break;
      }
  }

  void
  ValueExpressionParser::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

  std::ostream&
  ValueExpressionParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  ValueExpressionParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  ValueExpressionParser::debug_level_type
  ValueExpressionParser::debug_level () const
  {
    return yydebug_;
  }

  void
  ValueExpressionParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }


  int
  ValueExpressionParser::parse ()
  {
    /// Look-ahead and look-ahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the look-ahead.
    semantic_type yylval;
    /// Location of the look-ahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location yyerror_range[2];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* User initialization code.  */
    #line 37 "ValueExpressionParser.yy"
{
	     // Initialize the initial location.
	     //     @$.begin.filename = @$.end.filename = &driver.file;
}
  /* Line 555 of yacc.c.  */
#line 401 "ValueExpressionParser.tab.cc"
    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;
    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without look-ahead.  */
    yyn = yypact_[yystate];
    if (yyn == yypact_ninf_)
      goto yydefault;

    /* Read a look-ahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, &yylloc, driver);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yyn == 0 || yyn == yytable_ninf_)
	goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Accept?  */
    if (yyn == yyfinal_)
      goto yyacceptlab;

    /* Shift the look-ahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted unless it is eof.  */
    if (yychar != yyeof_)
      yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 2:
#line 145 "ValueExpressionParser.yy"
    { driver.setScalarResult((yysemantic_stack_[(1) - (1)].sfield));  ;}
    break;

  case 3:
#line 146 "ValueExpressionParser.yy"
    { driver.setVectorResult((yysemantic_stack_[(1) - (1)].vfield));  ;}
    break;

  case 4:
#line 147 "ValueExpressionParser.yy"
    { driver.setLogicalResult((yysemantic_stack_[(1) - (1)].sfield)); ;}
    break;

  case 5:
#line 150 "ValueExpressionParser.yy"
    { (yyval.vfield) = (yysemantic_stack_[(1) - (1)].vfield); ;}
    break;

  case 6:
#line 151 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[(3) - (1)].vfield) + *(yysemantic_stack_[(3) - (3)].vfield)); delete (yysemantic_stack_[(3) - (1)].vfield); delete (yysemantic_stack_[(3) - (3)].vfield); ;}
    break;

  case 7:
#line 152 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[(3) - (1)].sfield) * *(yysemantic_stack_[(3) - (3)].vfield)); delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].vfield); ;}
    break;

  case 8:
#line 153 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[(3) - (1)].vfield) * *(yysemantic_stack_[(3) - (3)].sfield)); delete (yysemantic_stack_[(3) - (1)].vfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 9:
#line 154 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[(3) - (1)].vfield) / *(yysemantic_stack_[(3) - (3)].sfield)); delete (yysemantic_stack_[(3) - (1)].vfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 10:
#line 155 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[(3) - (1)].vfield) ^ *(yysemantic_stack_[(3) - (3)].vfield)); delete (yysemantic_stack_[(3) - (1)].vfield); delete (yysemantic_stack_[(3) - (3)].vfield); ;}
    break;

  case 11:
#line 156 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[(3) - (1)].vfield) - *(yysemantic_stack_[(3) - (3)].vfield)); delete (yysemantic_stack_[(3) - (1)].vfield); delete (yysemantic_stack_[(3) - (3)].vfield);;}
    break;

  case 12:
#line 157 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(-*(yysemantic_stack_[(2) - (2)].vfield)); delete (yysemantic_stack_[(2) - (2)].vfield); ;}
    break;

  case 13:
#line 158 "ValueExpressionParser.yy"
    { (yyval.vfield) = (yysemantic_stack_[(3) - (2)].vfield); ;}
    break;

  case 14:
#line 159 "ValueExpressionParser.yy"
    { (yyval.vfield) = driver.doConditional((yysemantic_stack_[(5) - (1)].sfield),(yysemantic_stack_[(5) - (3)].vfield),(yysemantic_stack_[(5) - (5)].vfield),driver.makeVectorField(Foam::vector())); delete (yysemantic_stack_[(5) - (1)].sfield); delete (yysemantic_stack_[(5) - (3)].vfield); delete (yysemantic_stack_[(5) - (5)].vfield); ;}
    break;

  case 15:
#line 160 "ValueExpressionParser.yy"
    { (yyval.vfield) = driver.makePositionField(); ;}
    break;

  case 16:
#line 161 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::laplacian(*(yysemantic_stack_[(6) - (3)].fsfield),*(yysemantic_stack_[(6) - (5)].vfield))); delete (yysemantic_stack_[(6) - (3)].fsfield); delete (yysemantic_stack_[(6) - (5)].vfield); ;}
    break;

  case 17:
#line 162 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::average(*(yysemantic_stack_[(4) - (3)].fvfield))); delete (yysemantic_stack_[(4) - (3)].fvfield); ;}
    break;

  case 18:
#line 163 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::surfaceIntegrate(*(yysemantic_stack_[(4) - (3)].fvfield))); delete (yysemantic_stack_[(4) - (3)].fvfield); ;}
    break;

  case 19:
#line 164 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::surfaceSum(*(yysemantic_stack_[(4) - (3)].fvfield))); delete (yysemantic_stack_[(4) - (3)].fvfield); ;}
    break;

  case 20:
#line 165 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::grad(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 21:
#line 166 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::reconstruct(*(yysemantic_stack_[(4) - (3)].fsfield))); delete (yysemantic_stack_[(4) - (3)].fsfield); ;}
    break;

  case 22:
#line 167 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::curl(*(yysemantic_stack_[(4) - (3)].vfield))); delete (yysemantic_stack_[(4) - (3)].vfield); ;}
    break;

  case 23:
#line 168 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::div(*(yysemantic_stack_[(6) - (3)].fsfield),*(yysemantic_stack_[(6) - (5)].vfield))); delete (yysemantic_stack_[(6) - (3)].fsfield); delete (yysemantic_stack_[(6) - (5)].vfield); ;}
    break;

  case 24:
#line 169 "ValueExpressionParser.yy"
    {
            (yyval.vfield)=driver.getVectorField(*(yysemantic_stack_[(1) - (1)].vname));
                    ;}
    break;

  case 25:
#line 174 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[(3) - (1)].fsfield) + *(yysemantic_stack_[(3) - (3)].fsfield)); delete (yysemantic_stack_[(3) - (1)].fsfield); delete (yysemantic_stack_[(3) - (3)].fsfield); ;}
    break;

  case 26:
#line 175 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[(3) - (1)].fsfield) * *(yysemantic_stack_[(3) - (3)].fsfield)); delete (yysemantic_stack_[(3) - (1)].fsfield); delete (yysemantic_stack_[(3) - (3)].fsfield); ;}
    break;

  case 27:
#line 176 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[(3) - (1)].fvfield) & *(yysemantic_stack_[(3) - (3)].fvfield)); delete (yysemantic_stack_[(3) - (1)].fvfield); delete (yysemantic_stack_[(3) - (3)].fvfield); ;}
    break;

  case 28:
#line 177 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[(3) - (1)].fsfield) / *(yysemantic_stack_[(3) - (3)].fsfield)); delete (yysemantic_stack_[(3) - (1)].fsfield); delete (yysemantic_stack_[(3) - (3)].fsfield); ;}
    break;

  case 29:
#line 178 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(*(yysemantic_stack_[(3) - (1)].fsfield) - *(yysemantic_stack_[(3) - (3)].fsfield)); delete (yysemantic_stack_[(3) - (1)].fsfield); delete (yysemantic_stack_[(3) - (3)].fsfield);;}
    break;

  case 30:
#line 179 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(-*(yysemantic_stack_[(2) - (2)].fsfield)); delete (yysemantic_stack_[(2) - (2)].fsfield); ;}
    break;

  case 31:
#line 180 "ValueExpressionParser.yy"
    { (yyval.fsfield) = (yysemantic_stack_[(3) - (2)].fsfield); ;}
    break;

  case 32:
#line 181 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::mag(*(yysemantic_stack_[(4) - (3)].fsfield))); delete (yysemantic_stack_[(4) - (3)].fsfield); ;}
    break;

  case 33:
#line 182 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::mag(*(yysemantic_stack_[(4) - (3)].fvfield))); delete (yysemantic_stack_[(4) - (3)].fvfield); ;}
    break;

  case 34:
#line 183 "ValueExpressionParser.yy"
    { (yyval.fsfield) = driver.makeAreaField(); ;}
    break;

  case 35:
#line 184 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::fvc::snGrad(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 36:
#line 185 "ValueExpressionParser.yy"
    { (yyval.fsfield) = new Foam::surfaceScalarField(Foam::fvc::interpolate(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 37:
#line 186 "ValueExpressionParser.yy"
    {
            (yyval.fsfield)=driver.getFaceScalarField(*(yysemantic_stack_[(1) - (1)].fsname));
                    ;}
    break;

  case 38:
#line 191 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[(3) - (1)].fvfield) + *(yysemantic_stack_[(3) - (3)].fvfield)); delete (yysemantic_stack_[(3) - (1)].fvfield); delete (yysemantic_stack_[(3) - (3)].fvfield); ;}
    break;

  case 39:
#line 192 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[(3) - (1)].fsfield) * *(yysemantic_stack_[(3) - (3)].fvfield)); delete (yysemantic_stack_[(3) - (1)].fsfield); delete (yysemantic_stack_[(3) - (3)].fvfield); ;}
    break;

  case 40:
#line 193 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[(3) - (1)].fvfield) * *(yysemantic_stack_[(3) - (3)].fsfield)); delete (yysemantic_stack_[(3) - (1)].fvfield); delete (yysemantic_stack_[(3) - (3)].fsfield); ;}
    break;

  case 41:
#line 194 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[(3) - (1)].fvfield) ^ *(yysemantic_stack_[(3) - (3)].fvfield)); delete (yysemantic_stack_[(3) - (1)].fvfield); delete (yysemantic_stack_[(3) - (3)].fvfield); ;}
    break;

  case 42:
#line 195 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[(3) - (1)].fvfield) / *(yysemantic_stack_[(3) - (3)].fsfield)); delete (yysemantic_stack_[(3) - (1)].fvfield); delete (yysemantic_stack_[(3) - (3)].fsfield); ;}
    break;

  case 43:
#line 196 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(*(yysemantic_stack_[(3) - (1)].fvfield) - *(yysemantic_stack_[(3) - (3)].fvfield)); delete (yysemantic_stack_[(3) - (1)].fvfield); delete (yysemantic_stack_[(3) - (3)].fvfield);;}
    break;

  case 44:
#line 197 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(-*(yysemantic_stack_[(2) - (2)].fvfield)); delete (yysemantic_stack_[(2) - (2)].fvfield); ;}
    break;

  case 45:
#line 198 "ValueExpressionParser.yy"
    { (yyval.fvfield) = (yysemantic_stack_[(3) - (2)].fvfield); ;}
    break;

  case 46:
#line 199 "ValueExpressionParser.yy"
    { (yyval.fvfield) = driver.makeFacePositionField(); ;}
    break;

  case 47:
#line 200 "ValueExpressionParser.yy"
    { (yyval.fvfield) = driver.makeFaceField(); ;}
    break;

  case 48:
#line 201 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(Foam::fvc::snGrad(*(yysemantic_stack_[(4) - (3)].vfield))); delete (yysemantic_stack_[(4) - (3)].vfield); ;}
    break;

  case 49:
#line 202 "ValueExpressionParser.yy"
    { (yyval.fvfield) = new Foam::surfaceVectorField(Foam::fvc::interpolate(*(yysemantic_stack_[(4) - (3)].vfield))); delete (yysemantic_stack_[(4) - (3)].vfield); ;}
    break;

  case 50:
#line 203 "ValueExpressionParser.yy"
    {
            (yyval.fvfield)=driver.getFaceVectorField(*(yysemantic_stack_[(1) - (1)].fvname));
                    ;}
    break;

  case 51:
#line 208 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField((yysemantic_stack_[(1) - (1)].val)); ;}
    break;

  case 52:
#line 209 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[(3) - (1)].sfield) + *(yysemantic_stack_[(3) - (3)].sfield)); delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 53:
#line 210 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[(3) - (1)].sfield) - *(yysemantic_stack_[(3) - (3)].sfield)); delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 54:
#line 211 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[(3) - (1)].sfield) * *(yysemantic_stack_[(3) - (3)].sfield)); delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 55:
#line 212 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[(3) - (1)].sfield) / *(yysemantic_stack_[(3) - (3)].sfield)); delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 56:
#line 213 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::pow(*(yysemantic_stack_[(6) - (3)].sfield), (yysemantic_stack_[(6) - (5)].val))); delete (yysemantic_stack_[(6) - (3)].sfield); ;}
    break;

  case 57:
#line 214 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::log(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 58:
#line 215 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::exp(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 59:
#line 216 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[(3) - (1)].vfield) & *(yysemantic_stack_[(3) - (3)].vfield)); delete (yysemantic_stack_[(3) - (1)].vfield); delete (yysemantic_stack_[(3) - (3)].vfield);;}
    break;

  case 60:
#line 217 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(-*(yysemantic_stack_[(2) - (2)].sfield)); delete (yysemantic_stack_[(2) - (2)].sfield); ;}
    break;

  case 61:
#line 218 "ValueExpressionParser.yy"
    { (yyval.sfield) = (yysemantic_stack_[(3) - (2)].sfield); ;}
    break;

  case 62:
#line 219 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sqr(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 63:
#line 220 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sqrt(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 64:
#line 221 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sin(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 65:
#line 222 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::cos(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 66:
#line 223 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::tan(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 67:
#line 224 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(Foam::min(*(yysemantic_stack_[(4) - (3)].sfield)).value()); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 68:
#line 225 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(Foam::max(*(yysemantic_stack_[(4) - (3)].sfield)).value()); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 69:
#line 226 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::mag(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 70:
#line 227 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::magSqrGradGrad(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 71:
#line 228 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::mag(*(yysemantic_stack_[(4) - (3)].vfield))); delete (yysemantic_stack_[(4) - (3)].vfield); ;}
    break;

  case 72:
#line 229 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::div(*(yysemantic_stack_[(4) - (3)].vfield))); delete (yysemantic_stack_[(4) - (3)].vfield); ;}
    break;

  case 73:
#line 230 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::div(*(yysemantic_stack_[(4) - (3)].fsfield))); delete (yysemantic_stack_[(4) - (3)].fsfield); ;}
    break;

  case 74:
#line 231 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::div(*(yysemantic_stack_[(6) - (3)].fsfield),*(yysemantic_stack_[(6) - (5)].sfield))); delete (yysemantic_stack_[(6) - (3)].fsfield); delete (yysemantic_stack_[(6) - (5)].sfield); ;}
    break;

  case 75:
#line 232 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::laplacian(*(yysemantic_stack_[(4) - (3)].sfield))); delete (yysemantic_stack_[(4) - (3)].sfield); ;}
    break;

  case 76:
#line 233 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::laplacian(*(yysemantic_stack_[(6) - (3)].sfield),*(yysemantic_stack_[(6) - (5)].sfield))); delete (yysemantic_stack_[(6) - (3)].sfield); delete (yysemantic_stack_[(6) - (5)].sfield); ;}
    break;

  case 77:
#line 234 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::laplacian(*(yysemantic_stack_[(6) - (3)].fsfield),*(yysemantic_stack_[(6) - (5)].sfield))); delete (yysemantic_stack_[(6) - (3)].fsfield); delete (yysemantic_stack_[(6) - (5)].sfield); ;}
    break;

  case 78:
#line 235 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::average(*(yysemantic_stack_[(4) - (3)].fsfield))); delete (yysemantic_stack_[(4) - (3)].fsfield); ;}
    break;

  case 79:
#line 236 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::surfaceIntegrate(*(yysemantic_stack_[(4) - (3)].fsfield))); delete (yysemantic_stack_[(4) - (3)].fsfield); ;}
    break;

  case 80:
#line 237 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::surfaceSum(*(yysemantic_stack_[(4) - (3)].fsfield))); delete (yysemantic_stack_[(4) - (3)].fsfield); ;}
    break;

  case 81:
#line 238 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[(3) - (1)].vfield)->component(0)); delete (yysemantic_stack_[(3) - (1)].vfield); ;}
    break;

  case 82:
#line 239 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[(3) - (1)].vfield)->component(1)); delete (yysemantic_stack_[(3) - (1)].vfield); ;}
    break;

  case 83:
#line 240 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[(3) - (1)].vfield)->component(2)); delete (yysemantic_stack_[(3) - (1)].vfield); ;}
    break;

  case 84:
#line 241 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doConditional((yysemantic_stack_[(5) - (1)].sfield),(yysemantic_stack_[(5) - (3)].sfield),(yysemantic_stack_[(5) - (5)].sfield),driver.makeScalarField(0.)); delete (yysemantic_stack_[(5) - (1)].sfield); delete (yysemantic_stack_[(5) - (3)].sfield); delete (yysemantic_stack_[(5) - (5)].sfield); ;}
    break;

  case 85:
#line 242 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(M_PI); ;}
    break;

  case 86:
#line 243 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeDistanceField(); ;}
    break;

  case 87:
#line 244 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeRDistanceField(*(yysemantic_stack_[(4) - (3)].vfield)); delete (yysemantic_stack_[(4) - (3)].vfield); ;}
    break;

  case 88:
#line 245 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeVolumeField(); ;}
    break;

  case 89:
#line 246 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeRandomField(); ;}
    break;

  case 90:
#line 247 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeGaussRandomField(); ;}
    break;

  case 91:
#line 248 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(driver.runTime().deltaT().value()); ;}
    break;

  case 92:
#line 249 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(driver.runTime().time().value()); ;}
    break;

  case 93:
#line 250 "ValueExpressionParser.yy"
    { 
            (yyval.sfield)=driver.getScalarField(*(yysemantic_stack_[(1) - (1)].name));
				;}
    break;

  case 94:
#line 255 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(1); ;}
    break;

  case 95:
#line 256 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(0); ;}
    break;

  case 96:
#line 257 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeCellSetField(*(yysemantic_stack_[(4) - (3)].setname)); ;}
    break;

  case 97:
#line 258 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[(3) - (1)].sfield),std::less<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 98:
#line 259 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[(3) - (1)].sfield),std::greater<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 99:
#line 260 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[(3) - (1)].sfield),std::less_equal<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 100:
#line 261 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[(3) - (1)].sfield),std::greater_equal<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 101:
#line 262 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[(3) - (1)].sfield),std::equal_to<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 102:
#line 263 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[(3) - (1)].sfield),std::not_equal_to<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 103:
#line 264 "ValueExpressionParser.yy"
    { (yyval.sfield) = (yysemantic_stack_[(3) - (2)].sfield); ;}
    break;

  case 104:
#line 265 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalOp((yysemantic_stack_[(3) - (1)].sfield),std::logical_and<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 105:
#line 266 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalOp((yysemantic_stack_[(3) - (1)].sfield),std::logical_or<Foam::scalar>(),(yysemantic_stack_[(3) - (3)].sfield));  delete (yysemantic_stack_[(3) - (1)].sfield); delete (yysemantic_stack_[(3) - (3)].sfield); ;}
    break;

  case 106:
#line 267 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalNot((yysemantic_stack_[(2) - (2)].sfield)); delete (yysemantic_stack_[(2) - (2)].sfield); ;}
    break;

  case 107:
#line 270 "ValueExpressionParser.yy"
    {     (yyval.vfield) = driver.makeVectorField((yysemantic_stack_[(8) - (3)].sfield),(yysemantic_stack_[(8) - (5)].sfield),(yysemantic_stack_[(8) - (7)].sfield));  delete (yysemantic_stack_[(8) - (3)].sfield); delete (yysemantic_stack_[(8) - (5)].sfield); delete (yysemantic_stack_[(8) - (7)].sfield);}
    break;


    /* Line 675 of lalr1.cc.  */
#line 1056 "ValueExpressionParser.tab.cc"
	default: break;
      }
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[0] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse look-ahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[0] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (yyn != yypact_ninf_)
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[0] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    if (yyn == yyfinal_)
      goto yyacceptlab;

    yyerror_range[1] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the look-ahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		   &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyeof_ && yychar != yyempty_)
      yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval, &yylloc);

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  ValueExpressionParser::yysyntax_error_ (int yystate, int tok)
  {
    std::string res;
    YYUSE (yystate);
#if YYERROR_VERBOSE
    int yyn = yypact_[yystate];
    if (yypact_ninf_ < yyn && yyn <= yylast_)
      {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
	  if (yycheck_[x + yyn] == x && x != yyterror_)
	    ++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char ValueExpressionParser::yypact_ninf_ = -71;
  const short int
  ValueExpressionParser::yypact_[] =
  {
       337,   -71,   -71,   -71,   -70,   -71,   -71,   -71,   -30,   -17,
      -9,     3,     8,    14,    19,    32,    34,    46,    54,    56,
      61,    64,    68,    71,    72,    75,    81,    83,    89,   100,
     103,   108,   109,   111,   112,   113,   115,   337,   337,   337,
      20,   823,   819,    23,   -71,   337,   -20,   129,   133,   134,
     137,   337,   205,   272,   337,   337,   337,   272,   154,   154,
     154,   154,   142,   145,   337,   337,   337,   337,   337,   337,
     337,   337,   337,   337,   337,   148,   -71,    23,   191,   359,
     -52,   823,   819,   -71,   -71,   337,   337,   337,   337,   337,
     337,   -41,   337,   337,   337,   337,   337,   337,   337,   337,
     337,   337,   337,   337,   337,   -33,   -71,   -71,   -71,   -71,
     -71,   263,   151,   -71,   -71,   153,   155,   162,   167,   189,
     193,   272,   272,   686,   -15,   331,   376,   697,   393,    51,
     -51,   194,   154,   154,    47,   130,    66,   206,    85,   763,
     791,   -71,   -71,   105,   410,   427,   708,   444,   461,   478,
     495,   512,   529,   546,   563,   -71,   -71,   -71,   165,   165,
     -71,   -71,   148,   148,   -71,   -71,   -71,   819,   819,   819,
     819,   819,   819,   -26,   -26,   148,   -71,   -71,   339,   682,
     181,   -71,   337,   -71,   -71,   212,   252,   259,   337,   337,
     272,   -71,   -71,   796,   774,   -71,   154,   154,   154,   154,
     -71,   337,   154,   154,   154,   154,   154,   154,   -71,   -71,
     -71,   337,   -71,   337,   154,   -71,   -71,   -71,   -71,   -71,
     -71,   -71,   325,   -71,   -71,   -71,   -71,   -71,   -71,   -71,
     -71,   -71,   -71,   -71,   337,   337,   186,   -71,   -71,   -71,
     719,   580,   730,   597,   802,   785,   -71,   -71,   -19,   -19,
     -71,   -71,   -71,   741,   614,   -47,   216,   216,   -71,   -71,
     -71,   -71,   752,   631,   648,   264,   823,   819,   337,   -71,
     -71,   -71,   -71,   -71,   -71,   -71,   -71,   -71,   -71,   -71,
     -71,   665,   -71
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const unsigned char
  ValueExpressionParser::yydefact_[] =
  {
         0,    93,    24,    51,     0,    94,    95,    85,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     3,     2,     4,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,    60,     0,     0,     0,
       0,     0,     0,   106,     1,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    89,    90,    15,    88,
      86,     0,     0,    37,    50,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    91,    92,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    13,    61,   103,    11,     6,
       8,     9,    59,    10,    81,    82,    83,   102,   101,    97,
      98,   100,    99,    53,    52,     7,    54,    55,     0,     0,
     105,   104,     0,    87,    96,     0,     0,     0,     0,     0,
       0,    30,    44,     0,     0,    72,     0,     0,     0,     0,
      73,     0,     0,     0,     0,     0,     0,     0,    20,    22,
      70,     0,    75,     0,     0,    79,    18,    80,    19,    78,
      17,    21,     0,    57,    58,    71,    69,    64,    65,    66,
      67,    68,    62,    63,     0,     0,     0,    46,    47,    34,
       0,     0,     0,     0,     0,     0,    31,    45,    29,    25,
      26,    39,    28,     0,     0,     0,    43,    38,    40,    42,
      27,    41,     0,     0,     0,     0,    14,    84,     0,    48,
      35,    49,    36,    32,    33,    23,    74,    16,    77,    76,
      56,     0,   107
  };

  /* YYPGOTO[NTERM-NUM].  */
  const signed char
  ValueExpressionParser::yypgoto_[] =
  {
       -71,   -71,    52,    24,     2,     0,     5,   -71
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const short int
  ValueExpressionParser::yydefgoto_[] =
  {
        -1,    40,    81,   255,   125,    82,    77,    44
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const signed char ValueExpressionParser::yytable_ninf_ = -1;
  const unsigned short int
  ValueExpressionParser::yytable_[] =
  {
        42,   102,    45,   103,   104,    43,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   196,   197,   198,   199,
      84,   157,   212,   213,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   164,   165,   166,    76,    79,   100,
     101,   182,    46,    80,    83,   105,   198,   199,   196,   197,
     198,   199,    41,   106,   126,    47,   128,   130,   200,   201,
     135,   137,   139,    48,   143,   144,   145,   147,   148,   149,
     150,   151,   152,   153,   154,    49,   102,   124,   103,   104,
      50,   129,   134,   136,   138,   140,    51,   160,   161,    75,
      78,    52,   167,   168,   169,   170,   171,   172,   173,   174,
     176,   177,   179,   111,    53,   123,    54,   127,   180,   181,
     196,   197,   198,   199,   196,   197,   198,   199,    55,   146,
     215,    76,    79,   192,   194,   211,    56,    80,    57,   196,
     197,   198,   199,    58,   192,   194,    59,   158,   159,   217,
      60,   162,   163,    61,    62,   191,   193,    63,   196,   197,
     198,   199,   175,    64,   178,    65,   191,   193,   219,   113,
     114,    66,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,    67,    75,    78,    68,   115,   116,   117,   222,
      69,    70,   236,    71,    72,    73,   118,    74,   241,   243,
     147,   119,   245,   202,   203,   204,   205,   206,   207,   131,
     251,   254,   107,   216,   256,   257,   108,   109,   260,   261,
     110,   263,   112,   264,   244,   141,   245,   132,   142,    91,
     248,   249,   250,   252,   184,   185,   133,   186,   258,   259,
      87,    88,    89,    90,   187,   267,    91,   104,   244,   188,
     240,   242,   146,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   253,    85,    86,    87,    88,    89,    90,
     268,   189,    91,   262,   155,   190,   214,     0,   281,   202,
     203,   204,   205,   206,   207,     1,     2,   113,   114,   218,
       3,   204,   205,   206,   207,   237,   266,     4,     5,     6,
       7,     8,     9,    10,   115,   116,   117,    11,    12,    13,
      14,    15,    16,    17,   118,    18,    19,    20,    21,   119,
      22,    23,    24,    25,    26,    27,    28,   120,    30,    31,
      32,    33,    34,    35,    36,   238,    85,    86,    87,    88,
      89,    90,   239,   265,    91,   121,   183,   280,     0,     0,
       1,     2,     0,     0,   122,     3,     0,     0,     0,     0,
      39,     0,     4,     5,     6,     7,     8,     9,    10,     0,
       0,     0,    11,    12,    13,    14,    15,    16,    17,     0,
      18,    19,    20,    21,     0,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
       0,     0,     0,   234,   202,   203,   204,   205,   206,   207,
      37,     0,    85,    86,    87,    88,    89,    90,     0,    38,
      91,     0,     0,     0,     0,    39,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,     0,     0,     0,     0,
       0,     0,   156,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,     0,     0,     0,     0,     0,     0,   208,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
       0,     0,     0,     0,     0,     0,   210,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,     0,     0,     0,
       0,     0,     0,   223,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,     0,     0,     0,     0,     0,     0,
     224,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,     0,     0,     0,     0,     0,     0,   226,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,     0,     0,
       0,     0,     0,     0,   227,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,     0,     0,     0,     0,     0,
       0,   228,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,     0,     0,     0,     0,     0,     0,   229,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,     0,
       0,     0,     0,     0,     0,   230,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,     0,     0,     0,     0,
       0,     0,   231,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,     0,     0,     0,     0,     0,     0,   232,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
       0,     0,     0,     0,     0,     0,   233,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,     0,     0,     0,
       0,     0,     0,   270,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,     0,     0,     0,     0,     0,     0,
     272,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,     0,     0,     0,     0,     0,     0,   276,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,     0,     0,
       0,     0,     0,     0,   278,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,     0,     0,     0,     0,     0,
       0,   279,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,     0,     0,     0,     0,   235,     0,   282,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    85,
      86,    87,    88,    89,    90,     0,     0,    91,     0,   195,
      85,    86,    87,    88,    89,    90,     0,     0,    91,     0,
     209,    85,    86,    87,    88,    89,    90,     0,     0,    91,
       0,   225,    85,    86,    87,    88,    89,    90,     0,     0,
      91,     0,   269,    85,    86,    87,    88,    89,    90,     0,
       0,    91,     0,   271,    85,    86,    87,    88,    89,    90,
       0,     0,    91,     0,   275,    85,    86,    87,    88,    89,
      90,     0,     0,    91,     0,   277,   202,   203,   204,   205,
     206,   207,     0,     0,     0,     0,   220,   202,   203,   204,
     205,   206,   207,     0,     0,     0,     0,   247,   202,   203,
     204,   205,   206,   207,   196,   197,   198,   199,   274,   196,
     197,   198,   199,     0,   221,   196,   197,   198,   199,   246,
       0,     0,     0,     0,     0,   273,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    85,    86,    87,    88,
      89,    90,     0,     0,    91
  };

  /* YYCHECK.  */
  const short int
  ValueExpressionParser::yycheck_[] =
  {
         0,    53,    72,    55,    56,     0,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    63,    64,    65,    66,
       0,    73,    73,    74,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    75,    76,    77,    37,    38,    65,
      66,    74,    72,    38,    39,    45,    65,    66,    63,    64,
      65,    66,     0,    73,    54,    72,    56,    57,    73,    74,
      58,    59,    60,    72,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    72,    53,    53,    55,    56,
      72,    57,    58,    59,    60,    61,    72,    87,    88,    37,
      38,    72,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    51,    72,    53,    72,    55,   103,   104,
      63,    64,    65,    66,    63,    64,    65,    66,    72,    67,
      73,   121,   122,   121,   122,    74,    72,   122,    72,    63,
      64,    65,    66,    72,   132,   133,    72,    85,    86,    73,
      72,    89,    90,    72,    72,   121,   122,    72,    63,    64,
      65,    66,   100,    72,   102,    72,   132,   133,    73,     5,
       6,    72,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    72,   121,   122,    72,    22,    23,    24,    74,
      72,    72,   182,    72,    72,    72,    32,    72,   188,   189,
     190,    37,   190,    63,    64,    65,    66,    67,    68,    45,
     198,   201,    73,    73,   202,   203,    73,    73,   206,   207,
      73,   211,     7,   213,   190,    73,   214,    63,    73,    71,
     196,   197,   198,   199,    73,    72,    72,    72,   204,   205,
      65,    66,    67,    68,    72,   235,    71,    56,   214,    72,
     188,   189,   190,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,   201,    63,    64,    65,    66,    67,    68,
      74,    72,    71,   211,    73,    72,    72,    -1,   268,    63,
      64,    65,    66,    67,    68,     3,     4,     5,     6,    73,
       8,    65,    66,    67,    68,    73,   234,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    73,    63,    64,    65,    66,
      67,    68,    73,     8,    71,    63,    73,    73,    -1,    -1,
       3,     4,    -1,    -1,    72,     8,    -1,    -1,    -1,    -1,
      78,    -1,    15,    16,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    25,    26,    27,    28,    29,    30,    31,    -1,
      33,    34,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      -1,    -1,    -1,    54,    63,    64,    65,    66,    67,    68,
      63,    -1,    63,    64,    65,    66,    67,    68,    -1,    72,
      71,    -1,    -1,    -1,    -1,    78,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    -1,    54,    -1,    73,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    63,
      64,    65,    66,    67,    68,    -1,    -1,    71,    -1,    73,
      63,    64,    65,    66,    67,    68,    -1,    -1,    71,    -1,
      73,    63,    64,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    63,    64,    65,    66,    67,    68,    -1,    -1,
      71,    -1,    73,    63,    64,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    63,    64,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    63,    64,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    63,    64,    65,    66,
      67,    68,    -1,    -1,    -1,    -1,    73,    63,    64,    65,
      66,    67,    68,    -1,    -1,    -1,    -1,    73,    63,    64,
      65,    66,    67,    68,    63,    64,    65,    66,    73,    63,
      64,    65,    66,    -1,    73,    63,    64,    65,    66,    73,
      -1,    -1,    -1,    -1,    -1,    73,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    63,    64,    65,    66,
      67,    68,    -1,    -1,    71
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  ValueExpressionParser::yystos_[] =
  {
         0,     3,     4,     8,    15,    16,    17,    18,    19,    20,
      21,    25,    26,    27,    28,    29,    30,    31,    33,    34,
      35,    36,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    63,    72,    78,
      80,    81,    84,    85,    86,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    81,    84,    85,    81,    84,
      85,    81,    84,    85,     0,    63,    64,    65,    66,    67,
      68,    71,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    53,    55,    56,    84,    73,    73,    73,    73,
      73,    81,     7,     5,     6,    22,    23,    24,    32,    37,
      45,    63,    72,    81,    82,    83,    84,    81,    84,    82,
      84,    45,    63,    72,    82,    83,    82,    83,    82,    83,
      82,    73,    73,    84,    84,    84,    81,    84,    84,    84,
      84,    84,    84,    84,    84,    73,    73,    73,    81,    81,
      84,    84,    81,    81,    75,    76,    77,    84,    84,    84,
      84,    84,    84,    84,    84,    81,    84,    84,    81,    84,
      85,    85,    74,    73,    73,    72,    72,    72,    72,    72,
      72,    82,    83,    82,    83,    73,    63,    64,    65,    66,
      73,    74,    63,    64,    65,    66,    67,    68,    73,    73,
      73,    74,    73,    74,    72,    73,    73,    73,    73,    73,
      73,    73,    74,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    54,    54,    84,    73,    73,    73,
      81,    84,    81,    84,    82,    83,    73,    73,    82,    82,
      82,    83,    82,    81,    84,    82,    83,    83,    82,    82,
      83,    83,    81,    84,    84,     8,    81,    84,    74,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    84,    73
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  ValueExpressionParser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    63,    58,   308,   309,   310,   311,    60,
      62,   312,   313,    45,    43,    42,    47,    38,    94,   314,
     315,    46,    40,    41,    44,   120,   121,   122,    33
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  ValueExpressionParser::yyr1_[] =
  {
         0,    79,    80,    80,    80,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    82,    82,    82,    82,    82,
      82,    82,    82,    82,    82,    82,    82,    82,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
      83,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    86
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  ValueExpressionParser::yyr2_[] =
  {
         0,     2,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     2,     3,     5,     3,     6,     4,     4,     4,
       4,     4,     4,     6,     1,     3,     3,     3,     3,     3,
       2,     3,     4,     4,     3,     4,     4,     1,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     4,     4,
       1,     1,     3,     3,     3,     3,     6,     4,     4,     3,
       2,     3,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     6,     4,     6,     6,     4,     4,
       4,     3,     3,     3,     5,     1,     3,     4,     3,     3,
       3,     3,     3,     1,     1,     1,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     8
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const ValueExpressionParser::yytname_[] =
  {
    "$end", "error", "$undefined", "\"scalarID\"", "\"vectorID\"",
  "\"faceScalarID\"", "\"faceVectorID\"", "\"cellSetID\"", "\"number\"",
  "\"vector\"", "\"expression\"", "\"lexpression\"", "\"vexpression\"",
  "\"fsexpression\"", "\"fvexpression\"", "TOKEN_VECTOR", "TOKEN_TRUE",
  "TOKEN_FALSE", "TOKEN_pi", "TOKEN_rand", "TOKEN_randNormal",
  "TOKEN_position", "TOKEN_fposition", "TOKEN_face", "TOKEN_area",
  "TOKEN_volume", "TOKEN_dist", "TOKEN_rdist", "TOKEN_set", "TOKEN_div",
  "TOKEN_grad", "TOKEN_curl", "TOKEN_snGrad", "TOKEN_magSqrGradGrad",
  "TOKEN_laplacian", "TOKEN_integrate", "TOKEN_sum", "TOKEN_interpolate",
  "TOKEN_average", "TOKEN_reconstruct", "TOKEN_deltaT", "TOKEN_time",
  "TOKEN_pow", "TOKEN_log", "TOKEN_exp", "TOKEN_mag", "TOKEN_sin",
  "TOKEN_cos", "TOKEN_tan", "TOKEN_min", "TOKEN_max", "TOKEN_sqr",
  "TOKEN_sqrt", "'?'", "':'", "TOKEN_OR", "TOKEN_AND", "TOKEN_NEQ",
  "TOKEN_EQ", "'<'", "'>'", "TOKEN_GEQ", "TOKEN_LEQ", "'-'", "'+'", "'*'",
  "'/'", "'&'", "'^'", "TOKEN_NOT", "TOKEN_NEG", "'.'", "'('", "')'",
  "','", "'x'", "'y'", "'z'", "'!'", "$accept", "unit", "vexp", "fsexp",
  "fvexp", "exp", "lexp", "vector", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const ValueExpressionParser::rhs_number_type
  ValueExpressionParser::yyrhs_[] =
  {
        80,     0,    -1,    84,    -1,    81,    -1,    85,    -1,    86,
      -1,    81,    64,    81,    -1,    84,    65,    81,    -1,    81,
      65,    84,    -1,    81,    66,    84,    -1,    81,    68,    81,
      -1,    81,    63,    81,    -1,    63,    81,    -1,    72,    81,
      73,    -1,    85,    53,    81,    54,    81,    -1,    21,    72,
      73,    -1,    34,    72,    82,    74,    81,    73,    -1,    38,
      72,    83,    73,    -1,    35,    72,    83,    73,    -1,    36,
      72,    83,    73,    -1,    30,    72,    84,    73,    -1,    39,
      72,    82,    73,    -1,    31,    72,    81,    73,    -1,    29,
      72,    82,    74,    81,    73,    -1,     4,    -1,    82,    64,
      82,    -1,    82,    65,    82,    -1,    83,    67,    83,    -1,
      82,    66,    82,    -1,    82,    63,    82,    -1,    63,    82,
      -1,    72,    82,    73,    -1,    45,    72,    82,    73,    -1,
      45,    72,    83,    73,    -1,    24,    72,    73,    -1,    32,
      72,    84,    73,    -1,    37,    72,    84,    73,    -1,     5,
      -1,    83,    64,    83,    -1,    82,    65,    83,    -1,    83,
      65,    82,    -1,    83,    68,    83,    -1,    83,    66,    82,
      -1,    83,    63,    83,    -1,    63,    83,    -1,    72,    83,
      73,    -1,    22,    72,    73,    -1,    23,    72,    73,    -1,
      32,    72,    81,    73,    -1,    37,    72,    81,    73,    -1,
       6,    -1,     8,    -1,    84,    64,    84,    -1,    84,    63,
      84,    -1,    84,    65,    84,    -1,    84,    66,    84,    -1,
      42,    72,    84,    74,     8,    73,    -1,    43,    72,    84,
      73,    -1,    44,    72,    84,    73,    -1,    81,    67,    81,
      -1,    63,    84,    -1,    72,    84,    73,    -1,    51,    72,
      84,    73,    -1,    52,    72,    84,    73,    -1,    46,    72,
      84,    73,    -1,    47,    72,    84,    73,    -1,    48,    72,
      84,    73,    -1,    49,    72,    84,    73,    -1,    50,    72,
      84,    73,    -1,    45,    72,    84,    73,    -1,    33,    72,
      84,    73,    -1,    45,    72,    81,    73,    -1,    29,    72,
      81,    73,    -1,    29,    72,    82,    73,    -1,    29,    72,
      82,    74,    84,    73,    -1,    34,    72,    84,    73,    -1,
      34,    72,    84,    74,    84,    73,    -1,    34,    72,    82,
      74,    84,    73,    -1,    38,    72,    82,    73,    -1,    35,
      72,    82,    73,    -1,    36,    72,    82,    73,    -1,    81,
      71,    75,    -1,    81,    71,    76,    -1,    81,    71,    77,
      -1,    85,    53,    84,    54,    84,    -1,    18,    -1,    26,
      72,    73,    -1,    27,    72,    81,    73,    -1,    25,    72,
      73,    -1,    19,    72,    73,    -1,    20,    72,    73,    -1,
      40,    72,    73,    -1,    41,    72,    73,    -1,     3,    -1,
      16,    -1,    17,    -1,    28,    72,     7,    73,    -1,    84,
      59,    84,    -1,    84,    60,    84,    -1,    84,    62,    84,
      -1,    84,    61,    84,    -1,    84,    58,    84,    -1,    84,
      57,    84,    -1,    72,    85,    73,    -1,    85,    56,    85,
      -1,    85,    55,    85,    -1,    78,    85,    -1,    15,    72,
      84,    74,    84,    74,    84,    73,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned short int
  ValueExpressionParser::yyprhs_[] =
  {
         0,     0,     3,     5,     7,     9,    11,    15,    19,    23,
      27,    31,    35,    38,    42,    48,    52,    59,    64,    69,
      74,    79,    84,    89,    96,    98,   102,   106,   110,   114,
     118,   121,   125,   130,   135,   139,   144,   149,   151,   155,
     159,   163,   167,   171,   175,   178,   182,   186,   190,   195,
     200,   202,   204,   208,   212,   216,   220,   227,   232,   237,
     241,   244,   248,   253,   258,   263,   268,   273,   278,   283,
     288,   293,   298,   303,   308,   315,   320,   327,   334,   339,
     344,   349,   353,   357,   361,   367,   369,   373,   378,   382,
     386,   390,   394,   398,   400,   402,   404,   409,   413,   417,
     421,   425,   429,   433,   437,   441,   445,   448
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned short int
  ValueExpressionParser::yyrline_[] =
  {
         0,   145,   145,   146,   147,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   270
  };

  // Print the state stack on the debug stream.
  void
  ValueExpressionParser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  ValueExpressionParser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "), ";
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  ValueExpressionParser::token_number_type
  ValueExpressionParser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    78,     2,     2,     2,     2,    67,     2,
      72,    73,    65,    64,    74,    63,    71,    66,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    54,     2,
      59,     2,    60,    53,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    68,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      75,    76,    77,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    55,    56,
      57,    58,    61,    62,    69,    70
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int ValueExpressionParser::yyeof_ = 0;
  const int ValueExpressionParser::yylast_ = 894;
  const int ValueExpressionParser::yynnts_ = 8;
  const int ValueExpressionParser::yyempty_ = -2;
  const int ValueExpressionParser::yyfinal_ = 84;
  const int ValueExpressionParser::yyterror_ = 1;
  const int ValueExpressionParser::yyerrcode_ = 256;
  const int ValueExpressionParser::yyntokens_ = 79;

  const unsigned int ValueExpressionParser::yyuser_token_number_max_ = 315;
  const ValueExpressionParser::token_number_type ValueExpressionParser::yyundef_token_ = 2;

} // namespace ve

#line 273 "ValueExpressionParser.yy"


void ve::ValueExpressionParser::error (const ve::ValueExpressionParser::location_type& l,const std::string& m)
{
     driver.error (l, m);
}

